(* Title:  Knowledge/root.sml
   Author: Walther Neuper
   (c) due to copyright terms
 *)
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- rls Root_erls ------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

val thy = @{theory "Root"};
val ctxt = Proof_Context.init_global thy;

"----------- rls Root_erls ------------------------------";
"----------- rls Root_erls ------------------------------";
"----------- rls Root_erls ------------------------------";
val t = ParseC.parse_test @{context} "sqrt 1";
val SOME (t',_) = rewrite_set_ ctxt false Root_erls t;
if UnparseC.term @{context} t' = "1" then () else error "root.sml: diff.behav. sqrt 1";

val t = ParseC.parse_test @{context} "sqrt (- 1)";
val NONE = rewrite_set_ ctxt false Root_erls t;

val t = ParseC.parse_test @{context} "sqrt 0";
val SOME (t',_) = rewrite_set_ ctxt false Root_erls t;
if UnparseC.term @{context} t' = "0" then () else error "root.sml: diff.behav. sqrt 1";

